Batch upsert
curl --request POST \
--url https://api.hubapi.com/crm/auto-associations/2027-03-beta/batch/upsert \
--header 'Content-Type: application/json' \
--data '
{
"associationCustomizationsToUpsert": [
{
"engagementType": "<string>",
"subjectObjectTypeId": "<string>",
"targetObjectTypeId": "<string>"
}
]
}
'import requests
url = "https://api.hubapi.com/crm/auto-associations/2027-03-beta/batch/upsert"
payload = { "associationCustomizationsToUpsert": [
{
"engagementType": "<string>",
"subjectObjectTypeId": "<string>",
"targetObjectTypeId": "<string>"
}
] }
headers = {"Content-Type": "application/json"}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {'Content-Type': 'application/json'},
body: JSON.stringify({
associationCustomizationsToUpsert: [
{
engagementType: '<string>',
subjectObjectTypeId: '<string>',
targetObjectTypeId: '<string>'
}
]
})
};
fetch('https://api.hubapi.com/crm/auto-associations/2027-03-beta/batch/upsert', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.hubapi.com/crm/auto-associations/2027-03-beta/batch/upsert",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'associationCustomizationsToUpsert' => [
[
'engagementType' => '<string>',
'subjectObjectTypeId' => '<string>',
'targetObjectTypeId' => '<string>'
]
]
]),
CURLOPT_HTTPHEADER => [
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://api.hubapi.com/crm/auto-associations/2027-03-beta/batch/upsert"
payload := strings.NewReader("{\n \"associationCustomizationsToUpsert\": [\n {\n \"engagementType\": \"<string>\",\n \"subjectObjectTypeId\": \"<string>\",\n \"targetObjectTypeId\": \"<string>\"\n }\n ]\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://api.hubapi.com/crm/auto-associations/2027-03-beta/batch/upsert")
.header("Content-Type", "application/json")
.body("{\n \"associationCustomizationsToUpsert\": [\n {\n \"engagementType\": \"<string>\",\n \"subjectObjectTypeId\": \"<string>\",\n \"targetObjectTypeId\": \"<string>\"\n }\n ]\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://api.hubapi.com/crm/auto-associations/2027-03-beta/batch/upsert")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Content-Type"] = 'application/json'
request.body = "{\n \"associationCustomizationsToUpsert\": [\n {\n \"engagementType\": \"<string>\",\n \"subjectObjectTypeId\": \"<string>\",\n \"targetObjectTypeId\": \"<string>\"\n }\n ]\n}"
response = http.request(request)
puts response.read_body{
"completedAt": "2023-11-07T05:31:56Z",
"results": [
{
"associationCustomization": "FIVE_MOST_RECENTLY_ASSOCIATED",
"engagementType": "<string>",
"id": "<string>",
"subjectObjectTypeId": "<string>",
"targetObjectTypeId": "<string>"
}
],
"startedAt": "2023-11-07T05:31:56Z",
"status": "CANCELED",
"links": {},
"requestedAt": "2023-11-07T05:31:56Z"
}{
"completedAt": "2023-11-07T05:31:56Z",
"results": [
{
"associationCustomization": "FIVE_MOST_RECENTLY_ASSOCIATED",
"engagementType": "<string>",
"id": "<string>",
"subjectObjectTypeId": "<string>",
"targetObjectTypeId": "<string>"
}
],
"startedAt": "2023-11-07T05:31:56Z",
"status": "CANCELED",
"errors": [
{
"category": "<string>",
"context": {},
"errors": [
{
"message": "<string>",
"code": "<string>",
"context": "{missingScopes=[scope1, scope2]}",
"in": "<string>",
"subCategory": "<string>"
}
],
"links": {},
"message": "<string>",
"status": "<string>",
"id": "<string>",
"subCategory": {}
}
],
"links": {},
"numErrors": 123,
"requestedAt": "2023-11-07T05:31:56Z"
}{
"message": "Invalid input (details will vary based on the error)",
"correlationId": "aeb5f871-7f07-4993-9211-075dc63e7cbf",
"category": "VALIDATION_ERROR",
"links": {
"knowledge-base": "https://www.hubspot.com/products/service/knowledge-base"
}
}Auto associations
Batch upsert
Perform a batch upsert of auto-association settings in your HubSpot account. This endpoint allows you to update or insert multiple auto-association customizations at once, streamlining the process of managing these settings. The request body must include an array of association customizations to upsert.
POST
/
crm
/
auto-associations
/
2027-03-beta
/
batch
/
upsert
Batch upsert
curl --request POST \
--url https://api.hubapi.com/crm/auto-associations/2027-03-beta/batch/upsert \
--header 'Content-Type: application/json' \
--data '
{
"associationCustomizationsToUpsert": [
{
"engagementType": "<string>",
"subjectObjectTypeId": "<string>",
"targetObjectTypeId": "<string>"
}
]
}
'import requests
url = "https://api.hubapi.com/crm/auto-associations/2027-03-beta/batch/upsert"
payload = { "associationCustomizationsToUpsert": [
{
"engagementType": "<string>",
"subjectObjectTypeId": "<string>",
"targetObjectTypeId": "<string>"
}
] }
headers = {"Content-Type": "application/json"}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {'Content-Type': 'application/json'},
body: JSON.stringify({
associationCustomizationsToUpsert: [
{
engagementType: '<string>',
subjectObjectTypeId: '<string>',
targetObjectTypeId: '<string>'
}
]
})
};
fetch('https://api.hubapi.com/crm/auto-associations/2027-03-beta/batch/upsert', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.hubapi.com/crm/auto-associations/2027-03-beta/batch/upsert",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'associationCustomizationsToUpsert' => [
[
'engagementType' => '<string>',
'subjectObjectTypeId' => '<string>',
'targetObjectTypeId' => '<string>'
]
]
]),
CURLOPT_HTTPHEADER => [
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://api.hubapi.com/crm/auto-associations/2027-03-beta/batch/upsert"
payload := strings.NewReader("{\n \"associationCustomizationsToUpsert\": [\n {\n \"engagementType\": \"<string>\",\n \"subjectObjectTypeId\": \"<string>\",\n \"targetObjectTypeId\": \"<string>\"\n }\n ]\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://api.hubapi.com/crm/auto-associations/2027-03-beta/batch/upsert")
.header("Content-Type", "application/json")
.body("{\n \"associationCustomizationsToUpsert\": [\n {\n \"engagementType\": \"<string>\",\n \"subjectObjectTypeId\": \"<string>\",\n \"targetObjectTypeId\": \"<string>\"\n }\n ]\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://api.hubapi.com/crm/auto-associations/2027-03-beta/batch/upsert")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Content-Type"] = 'application/json'
request.body = "{\n \"associationCustomizationsToUpsert\": [\n {\n \"engagementType\": \"<string>\",\n \"subjectObjectTypeId\": \"<string>\",\n \"targetObjectTypeId\": \"<string>\"\n }\n ]\n}"
response = http.request(request)
puts response.read_body{
"completedAt": "2023-11-07T05:31:56Z",
"results": [
{
"associationCustomization": "FIVE_MOST_RECENTLY_ASSOCIATED",
"engagementType": "<string>",
"id": "<string>",
"subjectObjectTypeId": "<string>",
"targetObjectTypeId": "<string>"
}
],
"startedAt": "2023-11-07T05:31:56Z",
"status": "CANCELED",
"links": {},
"requestedAt": "2023-11-07T05:31:56Z"
}{
"completedAt": "2023-11-07T05:31:56Z",
"results": [
{
"associationCustomization": "FIVE_MOST_RECENTLY_ASSOCIATED",
"engagementType": "<string>",
"id": "<string>",
"subjectObjectTypeId": "<string>",
"targetObjectTypeId": "<string>"
}
],
"startedAt": "2023-11-07T05:31:56Z",
"status": "CANCELED",
"errors": [
{
"category": "<string>",
"context": {},
"errors": [
{
"message": "<string>",
"code": "<string>",
"context": "{missingScopes=[scope1, scope2]}",
"in": "<string>",
"subCategory": "<string>"
}
],
"links": {},
"message": "<string>",
"status": "<string>",
"id": "<string>",
"subCategory": {}
}
],
"links": {},
"numErrors": 123,
"requestedAt": "2023-11-07T05:31:56Z"
}{
"message": "Invalid input (details will vary based on the error)",
"correlationId": "aeb5f871-7f07-4993-9211-075dc63e7cbf",
"category": "VALIDATION_ERROR",
"links": {
"knowledge-base": "https://www.hubspot.com/products/service/knowledge-base"
}
}Supported products
Supported products
Required Scopes
Required Scopes
Body
application/json
Response
successful operation
Last modified on November 16, 2026
Was this page helpful?